Program How_To_Make_A_Linked_List_Work; { Copyright 1996 by, Brian M. Kueck }
Uses Crt;                               { This source code is freeware as
                                          long as it is distributed as
                                          unedited.  Otherwise, you are in
                                          violation of U.S. copyright laws. }
Type
   Food    = ^Whopper;  { Pointer to the record.  Needed to make the list. }
   Whopper = Record
                Burgers : Integer; { Some data in the list. }
                Fries   : Integer; { Some more data in the list. }
                Shakes  : String;  { Even more data in the list. }
                Next    : Food;    { The next record in the list.
                                     Now you can go forward. }
                Last    : Food;    { The previous record in the list.
                                     Now you can go backwards. }
             End;

Var
   Pause       : Char;    { Pauses the pc and waits for a user's input. }
   Test        : File of Whopper; { "Test.Dat" is a file the only file
                                    that this program creates and you
                                    may delete it without any harm to your
                                    system. }
   Breakfast   : Food;    { 1st pass at reading the file. }
   Lunch       : Food;    { 2nd pass at reading the file. }
   Dinner      : Food;    { 3rd pass at reading the file. }
                          { Hungry yet? }
   First_Order : Food;    { First record in the linked list.  Pointer does
                            not move throughout the list. }
   Order       : Food;    { Current record in the linked list.  Pointer does
                            move throughout the list. }
   Counter     : Integer; { User inputs # of items in the list. }
   Loop        : Integer; { Loop it over...  and over... and over... }

Begin
   Clrscr;
   New (First_Order);
   Order       := First_Order;
   Order^.Next := Nil;
   Order^.Last := Nil;
   Write ('Enter a number: ');
   Readln (Counter);
   Write (' ':15, 'Hit <ENTER> ', Counter);
    If (Counter = 1) Then
      Write (' time ')
   Else
      Write (' times ');
   Writeln ('per line to scroll forward.');

   Writeln;
   Write ('This is the data which is being created in order to write it ');
   Writeln ('to the file.');
   For Loop := 1 to Counter Do
   Begin
      Order^.Burgers := Loop;
      Order^.Fries := (Loop*3);
      If (Loop Mod 2 = 0) Then
         Order^.Shakes := 'NO'
      Else
         Order^.Shakes := 'YES';
      Writeln (Order^.Burgers, ',', Order^.Fries, ',', Order^.Shakes);
      Pause := Readkey;
      New (Order^.Next);
      Order := Order^.Next;
      Order^.Next := Nil;
   End;

   Order := First_Order;
   Assign (Test, 'Test.Dat');
   Rewrite (Test);
   Writeln;
   Writeln ('Here is the data as it is being written to the file. ');
   For Loop := 1 to Counter Do
   Begin
      Writeln (Order^.Burgers, ',', Order^.Fries, ',', Order^.Shakes);
      Pause := Readkey;
      Write (Test, Order^);
      Order := Order^.Next;
   End;
   Close (Test);

   { Frees up some RAM by getting rid of old pointers. }
   Order := First_Order;
   While (Order^.Next <> Nil) Do
   Begin
      Order := Order^.Next;
      Dispose (First_Order);
      First_Order := Order;
   End;

   { 1st file read. }
   Writeln;
   Writeln ('This is the data which was read from the file. (1st Time)');
   New (Breakfast);
   Assign (Test, 'Test.Dat');
   Reset (Test);
   For Loop := 1 to Counter Do
   Begin
      Read (Test, Breakfast^);
      Write (Breakfast^.Burgers, ',', Breakfast^.Fries, ',');
      Writeln (Breakfast^.Shakes);
      Pause := Readkey;
   End;
   Close (Test);

   New (Order);
   Order := Breakfast;
   While (Order^.Last <> Nil) Do
   Begin
      Order := Order^.Last;
      Dispose (Breakfast);
      Breakfast := Order;
   End;

   { 2nd file read. }
   Writeln;
   Writeln ('This is the data which was read from the file. (2nd Time)');
   New (Lunch);
   Assign (Test, 'Test.Dat');
   Reset (Test);
   For Loop := 1 to Counter Do
   Begin
      Read (Test, Lunch^);
      Write (Lunch^.Burgers, ',', Lunch^.Fries, ',');
      Writeln (Lunch^.Shakes);
      Pause := Readkey;
   End;
   Close (Test);

   Order := Lunch;
   While (Order^.Last <> Nil) Do
   Begin
      Order := Order^.Last;
      Dispose (Lunch);
      Lunch := Order;
   End;

   { 3rd file read. }
   Writeln;
   Writeln ('This is the data which was read from the file. (3rd Time)');
   New (Dinner);
   Assign (Test, 'Test.Dat');
   Reset (Test);
   For Loop := 1 to Counter Do
   Begin
      Read (Test, Dinner^);
      Write (Dinner^.Burgers, ',', Dinner^.Fries, ',');
      Writeln (Dinner^.Shakes);
      Pause := Readkey;
   End;
   Close (Test);

   Order := Dinner;
   While (Order^.Last <> Nil) Do
   Begin
      Order := Order^.Last;
      Dispose (Dinner);
      Dinner := Order;
   End;

   Writeln;
   Write ('Now that you know that this program works, ');
   Writeln ('hit <ENTER> to return to DOS.');
   Pause := Readkey;
End.